// ngCordova服务
angular.module("starter.services").factory("cordovaService", [
  "$cordovaNetwork",
  "$cordovaDevice",
  "$cordovaBatteryStatus",
  function ($cordovaNetwork, $cordovaDevice, $cordovaBatteryStatus) {
    //
    var getDeviceInfo = function () {
      return {
        // device: $cordovaDevice.getDevice(),
        model: $cordovaDevice.getModel(),
        platform: $cordovaDevice.getPlatform(),
        UUID: $cordovaDevice.getUUID(),
        version: $cordovaDevice.getVersion(),
      };
    };

    //
    var getNetworkInfo = function () {
      return {
        network: $cordovaNetwork.getNetwork(),
        isOnline: $cordovaNetwork.isOnline(),
        isOffline: $cordovaNetwork.isOffline(),
      };
    };

    // https://github.com/2026635978/BaiduLBS
    // 目前只支持Android
    var getCurrentLocationByBaiduLBS = function (callback) {
      cordova.plugins.BaiduLBS.getCurrentLocation(
        function (location) {
          if (callback && callback.onSuccess) {
            callback.onSuccess(location);
          }
        },
        function (err) {
          if (callback && callback.onError) {
            callback.onError(err);
          }
        }
      );
    };

    return {
      getDeviceInfo: getDeviceInfo,
      getNetworkInfo: getNetworkInfo,
      getCurrentLocationByBaiduLBS: getCurrentLocationByBaiduLBS,
    };
  },
]);
