angular
  .module("starter.controllers")

  .controller(
    "ActivityWorldMineCtrl",
    function (
      $scope,
      $ionicHistory,
      $ionicSlideBoxDelegate,
      $state,
      apiService,
      uiService,
      $ionicLoading,
      $ionicTabsDelegate,
      broadcastService,
      broadcastConstants
    ) {
      $scope.tabNames = ["所有活动", "我参与的", " 我创建的"];
      $scope.slectIndex = 0;
      $scope.activeSlide = function (index) {
        //点击时候触发
        $scope.slectIndex = index;
        $ionicSlideBoxDelegate.slide(index);
      };
      $scope.slideChanged = function (index) {
        //滑动时候触发
        $scope.slectIndex = index;
      };
      $scope.pages = [
        "modules/activity/activity_all.html",
        "modules/activity/activity_mine_enroll.html",
        "modules/activity/activity_mine_owner.html",
      ];
      $scope.desc = true;

      /**************************************************所有活动的相关配置***************************************************/
      //所有活动的失败消息
      $scope.refreshFailedAll = false;
      $scope.refreshFailedMsgAll = "刷新失败，请重新下拉";
      $scope.loadMoreFailedAll = false;
      $scope.loadMoreFailedMsgAll = "加载失败";
      $scope.noMoreBooksMsgAll = "已经加载所有活动";
      //所有活动的初始数据
      $scope.activities = [];
      $scope.elementsCountAll = 0;
      $scope.pageAll = -1;
      $scope.sizeAll = 10;
      $scope.totalPagesAll = -1;
      // 重置数据
      $scope.clearDataAll = function () {
        $scope.refreshFailedAll = false;
        $scope.loadMoreFailedAll = false;
        $scope.elementsCountAll = 0;
        $scope.activities = [];
        $scope.totalPagesAll = -1;
        $scope.pageAll = -1;
      };
      //下拉刷新
      $scope.refreshAll = function () {
        // 刷新重置数据
        $scope.clearDataAll();
        //
        $scope.retrieveActivities();
      };
      // 加载更多
      $scope.loadMoreAll = function (ignoreLoadMoreFailedAll) {
        if ($scope.refreshFailedAll) {
          console.warn(
            "加载首页活动，加载下一页只能在之前加载成功的情况下进行。"
          );
          return;
        }
        if ($scope.loadMoreFailedAll) {
          if (ignoreLoadMoreFailedAll) {
          } else {
            console.warn(
              "上次加载更多图书失败，加载下一页只能在之前加载成功的情况下进行。"
            );
            return;
          }
        }
        //
        // 只要首页查询成功，page就已经是0了。
        if ($scope.pageAll >= 0 && $scope.pageAll < $scope.totalPagesAll - 1) {
          $scope.loadMoreFailedAll = false;
          $scope.retrieveActivities();
        } else {
          console.warn(
            "查询所有活动列表，当前已经是最后一页，不需要加载下一页。"
          );
        }
      };
      // 所有活动
      $scope.retrieveActivities = function () {
        if (
          $scope.pageAll == $scope.totalPagesAll - 1 &&
          $scope.totalPagesAll >= 0
        ) {
          console.warn("查询所有活动列表，已经是最后一页，不能再往后查询了。");
          return;
        }
        if ($scope.isQueryAutoAll) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询，请稍候..." });
        }
        apiService.retrieveApprovedStatusActivities(
          $scope.pageAll + 1,
          $scope.sizeAll,
          retrieveActivitiesCallback
        );
      };
      var retrieveActivitiesCallback = {
        onSuccess: function (data, status, headers, config) {
          // 判断当前是下拉操作还是上拉操作
          if ($scope.pageAll == -1) {
            // 下拉：首页
            $scope.refreshFailedAll = false;
          } else {
            // 上拉：原始页码大于等于0
            $scope.loadMoreFailedAll = false;
          }
          // 查询成功，赋值数据
          $scope.elementsCountAll = data.elementsCount;
          $scope.totalPagesAll = data.totalPages;
          $scope.pageAll = $scope.pageAll + 1;
          $scope.activities = $scope.activities.concat(data.data);
          // Restful Serve 参数不一致造成的，需要做一步一致性转换
          for (var i = 0; i < $scope.activities.length; i++) {
            $scope.activities[i].title = $scope.activities[i].activityTitle;
          }
          fixActivitiesPreviewPic($scope.activities);
        },
        onError: function (data, status, headers, config) {},
        onFinally: function () {
          // 隐藏进度条
          if ($scope.isQueryAutoAll == true) {
            $scope.$broadcast("scroll.refreshComplete");
          } else {
            $scope.$broadcast("scroll.infiniteScrollComplete");
          }
          if ($scope.isQueryAutoAll) {
            $scope.isQueryAutoAll = false;
            $ionicLoading.hide();
          } else {
            if ($scope.pageAll == -1) {
              // 首页查询失败
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageAll == 0 && !$scope.refreshFailedAll) {
              // 首页查询成功
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageAll == 0 && $scope.loadMoreFailedAll) {
              // 第一次更多查询失败
              $scope.$broadcast("scroll.infiniteScrollComplete");
            } else if ($scope.pageAll > 0) {
              // 第n>1次查询更多
              $scope.$broadcast("scroll.infiniteScrollComplete");
            }
          }
        },
      };
      /*********************************************我参与的活动的相关配置*****************************************/
      //我参与活动的失败消息
      $scope.refreshFailedEnroll = false;
      $scope.refreshFailedMsgEnroll = "刷新失败，请重新下拉";
      $scope.loadMoreFailedEnroll = false;
      $scope.loadMoreFailedMsgEnroll = "加载失败";
      $scope.noMoreBooksMsgEnroll = "已经加载所有活动";
      //我参与活动的初始数据
      // 我参与的活动
      $scope.enrollActivities = []; // 包含activity和报名id： [{activiy, id}, {activiy, id}, {activiy, id}, {activiy, id}]
      $scope.elementsCountEnroll = 0;
      $scope.pageEnroll = -1;
      $scope.sizeEnroll = 2;
      $scope.totalPagesEnroll = -1;
      $scope.sortedColumn = "id";
      // 重置数据
      $scope.clearDataEnroll = function () {
        $scope.refreshFailedEnroll = false;
        $scope.loadMoreFailedEnroll = false;
        $scope.elementsCountEnroll = 0;
        $scope.enrollActivities = [];
        $scope.totalPagesEnroll = -1;
        $scope.pageEnroll = -1;
      };
      //Enroll下拉刷新
      $scope.refreshEnroll = function () {
        // 刷新重置数据
        $scope.clearDataEnroll();
        //
        $scope.retrieveEnrollActivities();
      };
      // 加载更多
      $scope.loadMoreEnroll = function (ignoreLoadMoreFailedEnroll) {
        if ($scope.refreshFailedEnroll) {
          console.warn(
            "加载首页活动，加载下一页只能在之前加载成功的情况下进行。"
          );
          return;
        }
        if ($scope.loadMoreFailedEnroll) {
          if (ignoreLoadMoreFailedEnroll) {
          } else {
            console.warn(
              "上次加载更多活动失败，加载下一页只能在之前加载成功的情况下进行。"
            );
            return;
          }
        }
        //
        // 只要首页查询成功，page就已经是0了。
        if (
          $scope.pageEnroll >= 0 &&
          $scope.pageEnroll < $scope.totalPagesEnroll - 1
        ) {
          $scope.loadMoreFailedEnroll = false;
          $scope.retrieveEnrollActivities();
        } else {
          console.warn(
            "查询我参与活动的列表，当前已经是最后一页，不需要加载下一页。"
          );
        }
      };
      $scope.retrieveEnrollActivities = function () {
        if (
          $scope.pageEnroll == $scope.totalPagesEnroll - 1 &&
          $scope.totalPagesEnroll >= 0
        ) {
          console.warn(
            "查询我参与活动的列表，已经是最后一页，不能再往后查询了。"
          );
          return;
        }
        if ($scope.isQueryAutoEnroll) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询，请稍候..." });
        }
        apiService.retrieveEnrollActivities(
          $scope.pageEnroll + 1,
          $scope.sizeEnroll,
          $scope.sortedColumn,
          $scope.user.account,
          retrieveEnrollActivitiesCallback
        );
      };
      var retrieveEnrollActivitiesCallback = {
        onSuccess: function (data, status, headers, config) {
          // 判断当前是下拉操作还是上拉操作
          if ($scope.pageEnroll == -1) {
            // 下拉：首页
            $scope.refreshFailedEnroll = false;
          } else {
            // 上拉：原始页码大于等于0
            $scope.loadMoreFailedEnroll = false;
          }
          // 查询成功，赋值数据
          $scope.elementsCountEnroll = data.elementsCount;
          $scope.totalPagesEnroll = data.totalPages;
          $scope.pageEnroll = $scope.pageEnroll + 1;
          $scope.enrollActivities = $scope.enrollActivities.concat(data.data);
          //$scope.enrollActivities = data.data;
          // 我参与的活动与其它的活动列表的活动数据结构不一样，需要重构一个可用的列表。
          if (!_.isEmpty($scope.enrollActivities)) {
            var tmpActivities = [];
            $scope.enrollActivities.forEach(function (activity) {
              tmpActivities.push(activity.activity);
            }, this);
            fixActivitiesPreviewPic(tmpActivities);
          }
        },
        onError: function (data, status, headers, config) {},
        onFinally: function () {
          // 隐藏进度条
          if ($scope.isQueryAutoEnroll == true) {
            $scope.$broadcast("scroll.refreshComplete");
          } else {
            $scope.$broadcast("scroll.infiniteScrollComplete");
          }
          if ($scope.isQueryAutoEnroll) {
            $scope.isQueryAutoEnroll = false;
            $ionicLoading.hide();
          } else {
            if ($scope.pageEnrolll == -1) {
              // 首页查询失败
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageEnroll == 0 && !$scope.refreshFailedEnroll) {
              // 首页查询成功
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageEnroll == 0 && $scope.loadMoreFailedEnroll) {
              // 第一次更多查询失败
              $scope.$broadcast("scroll.infiniteScrollComplete");
            } else if ($scope.pageEnroll > 0) {
              // 第n>1次查询更多
              $scope.$broadcast("scroll.infiniteScrollComplete");
            }
          }
        },
      };
      /***********************************************我创建活动的相关配置***********************************************/
      //我创建活动的失败消息
      $scope.refreshFailedOwner = false;
      $scope.refreshFailedMsgOwner = "刷新失败，请重新下拉";
      $scope.loadMoreFailedOwner = false;
      $scope.loadMoreFailedMsgOwner = "加载失败";
      $scope.noMoreBooksMsgOwner = "已经加载所有活动";
      //我创建活动的初始数据
      $scope.ownerActivities = []; // 只包含activity： [activiy, activiy, activiy, activiy, activiy,
      $scope.elementsCountOwner = 0;
      $scope.pageOwner = -1;
      $scope.sizeOwner = 2;
      $scope.totalPagesOwner = -1;
      // 重置数据
      $scope.clearDataOwner = function () {
        $scope.refreshFailedOwner = false;
        $scope.loadMoreFailedOwner = false;
        $scope.elementsCountOwner = 0;
        $scope.totalPagesOwner = -1;
        $scope.pageOwner = -1;
        $scope.ownerActivities = [];
      };
      //Owner下拉刷新
      $scope.refreshOwner = function () {
        // 刷新重置数据
        $scope.clearDataOwner();
        //
        $scope.retrieveOwnerActivities();
      };
      // 加载更多
      $scope.loadMoreOwner = function (ignoreLoadMoreFailedOwner) {
        if ($scope.refreshFailedOwner) {
          console.warn(
            "加载首页活动，加载下一页只能在之前加载成功的情况下进行。"
          );
          return;
        }
        if ($scope.loadMoreFailedOwner) {
          if (ignoreLoadMoreFailedOwner) {
          } else {
            console.warn(
              "上次加载更多活动失败，加载下一页只能在之前加载成功的情况下进行。"
            );
            return;
          }
        }
        //
        // 只要首页查询成功，page就已经是0了。
        if (
          $scope.pageOwner >= 0 &&
          $scope.pageOwner < $scope.totalPagesOwner - 1
        ) {
          $scope.loadMoreFailedOwner = false;
          $scope.retrieveOwnerActivities();
        } else {
          console.warn(
            "查询创建活动列表，当前已经是最后一页，不需要加载下一页。"
          );
        }
      };
      $scope.retrieveOwnerActivities = function () {
        if (
          $scope.pageOwner == $scope.totalPagesOwner - 1 &&
          $scope.totalPagesOwner >= 0
        ) {
          console.warn("查询创建活动列表，已经是最后一页，不能再往后查询了。");
          return;
        }
        if ($scope.isQueryAutoOwner) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询，请稍候..." });
        }
        apiService.retrieveOwnerActivities(
          $scope.pageOwner + 1,
          $scope.sizeOwner,
          $scope.user.account,
          retrieveOwnerActivitiesCallback
        );
      };
      var retrieveOwnerActivitiesCallback = {
        onSuccess: function (data, status, headers, config) {
          // 判断当前是下拉操作还是上拉操作
          if ($scope.pageOwner == -1) {
            // 下拉：首页
            $scope.refreshFailedOwner = false;
          } else {
            // 上拉：原始页码大于等于0
            $scope.loadMoreFailedOwner = false;
          }
          // 查询成功，赋值数据
          $scope.elementsCountOwner = data.elementsCount;
          $scope.totalPagesOwner = data.totalPages;
          $scope.pageOwner = $scope.pageOwner + 1;
          $scope.ownerActivities = $scope.ownerActivities.concat(data.data);
          // $scope.ownerActivities = data.data;
          fixActivitiesPreviewPic($scope.ownerActivities);
        },
        onError: function (data, status, headers, config) {},
        onFinally: function () {
          // 隐藏进度条
          if ($scope.isQueryAutoOwner == true) {
            $scope.$broadcast("scroll.refreshComplete");
          } else {
            $scope.$broadcast("scroll.infiniteScrollComplete");
          }
          if ($scope.isQueryAutoOwner) {
            $scope.isQueryAutoOwner = false;
            $ionicLoading.hide();
          } else {
            if ($scope.pageOwner == -1) {
              // 首页查询失败
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageOwner == 0 && !$scope.refreshFailedOwner) {
              // 首页查询成功
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.pageOwner == 0 && $scope.loadMoreFailedOwner) {
              // 第一次更多查询失败
              $scope.$broadcast("scroll.infiniteScrollComplete");
            } else if ($scope.pageOwner > 0) {
              // 第n>1次查询更多
              $scope.$broadcast("scroll.infiniteScrollComplete");
            }
          }
        },
      };

      function fixActivityPreviewPic(activity) {
        if (activity) {
          if (_.isEmpty(activity.previewPic)) {
            activity.previewPic = "img/activity_default.png";
          }
        }
      }
      function fixActivitiesPreviewPic(activities) {
        if (!_.isEmpty(activities)) {
          activities.forEach(function (activity) {
            fixActivityPreviewPic(activity);
          }, this);
        }
      }

      //
      $scope.goActivityDetail = function (activity) {
        //
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.activitydetail", {
            activity: activity,
          });
        });
      };
      //
      $scope.goCreateActivity = function () {
        $state.go("tab.activityCreate");
      };
      /*****************wsc-change******************/
      //监听和反监听
      var onActivityChangedListener = function (data) {
        //console.log('BookhomeCtrl', angular.toJson(data, true));
        $scope.retrieveActivities();
        $scope.retrieveEnrollActivities();
        $scope.retrieveOwnerActivities();
      };
      broadcastService.register(
        broadcastConstants.names.onActivityChanged,
        onActivityChangedListener
      );
      broadcastService.register(
        broadcastConstants.names.onPatchActivity,
        onActivityChangedListener
      ); // 使用同一个listener即可
      $scope.$on("$destroy", function () {
        broadcastService.unregister(
          broadcastConstants.names.onActivityChanged,
          onActivityChangedListener
        );
        broadcastService.unregister(
          broadcastConstants.names.onPatchActivity,
          onActivityChangedListener
        );
      });

      $scope.isQueryAutoAll = true;
      $scope.isQueryAutoEnroll = true;
      $scope.isQueryAutoOwner = true;
      //$scope.refreshAll();
      $ionicTabsDelegate.showBar(false);

      //
      $scope.retrieveActivities();
      $scope.retrieveEnrollActivities();
      $scope.retrieveOwnerActivities();
    }
  );
