angular
  .module("starter.controllers")

  .controller(
    "historyLoanedBookDetailCtrl",
    function (
      $controller,
      $scope,
      $stateParams,
      $ionicLoading,
      $ionicSlideBoxDelegate,
      apiService,
      uiService,
      bookService,
      ngCordovaService,
      $ionicTabsDelegate
    ) {
      // ----------------------------------------------------------------------------------------------------------------
      $scope.historyLoanedBook = $stateParams.historyLoanedBook; // 当前图书
      $scope.allowLoanedBooks = []; // 可借阅图书
      $scope.totalBooks = []; // 所有图书

      // ----------------------------------------------------------------------------------------------------------------
      // 获取图书详情的回调方法
      var callback = {
        onSuccess: onSuccess,
        onError: onError,
        onBefore: onBefore,
        onAfter: onAfter,
      };
      function onSuccess(data) {
        if (data) {
          $scope.allowLoanedBooks = data.allowLoanedBooks;
          $scope.totalBooks = data.totalBooks;
        }
      }
      function onError() {
        // TODO
      }
      function onBefore() {
        uiService.ionicLoadingShow({ templateTitle: "加载中..." });
      }
      function onAfter() {
        $ionicLoading.hide();
      }

      // ----------------------------------------------------------------------------------------------------------------
      $ionicTabsDelegate.showBar(false);

      // ----------------------------------------------------------------------------------------------------------------
      // 获取base controller，并将其扩展至当前controller中。
      var baseBookDetailCtrl = $controller("baseBookDetailCtrl", {
        $scope: $scope,
      });
      angular.extend(this, baseBookDetailCtrl);
      if ($scope.historyLoanedBook) {
        $scope.init($scope.historyLoanedBook.isbn); // init函数是base controller中的
      }
    }
  );
