angular
  .module("starter.controllers")

  .controller(
    "MyBorrowCtrl",
    function (
      $compile,
      $scope,
      $state,
      $stateParams,
      $ionicHistory,
      uiService,
      $ionicLoading,
      $ionicSlideBoxDelegate,
      apiService,
      $ionicTabsDelegate
    ) {
      $scope.tabNames = ["当前借阅", "历史借阅"];
      $scope.slectIndex = 0;
      $scope.activeSlide = function (index) {
        //点击时候触发
        $scope.slectIndex = index;
        $ionicSlideBoxDelegate.slide(index);
      };
      $scope.slideChanged = function (index) {
        //滑动时候触发
        $scope.slectIndex = index;
        if ($scope.tabNames[index] == "当前借阅") {
          $scope.showButton = false;
          uiService.ionicLoadingShow({ templateTitle: "正在查询..." });
          apiService.retrieveBorrowInfo(
            $scope.user.borrowID,
            retrieveBorrowInfoCallback
          );
        } else if ($scope.tabNames[index] == "历史借阅") {
          uiService.ionicLoadingShow({ templateTitle: "正在查询..." });
          apiService.retrieveLoadHistory(
            $scope.user.borrowID,
            retrieveHistoryBorrowInfoCallback
          );
        }
      };
      $scope.pages = [
        "modules/borrowbook/loaned_books.html",
        "modules/borrowbook/history_loaned_books.html",
      ];

      //
      $scope.loanedBooks = null;
      $scope.historyLoanedBooks = null;
      $scope.checkReturnBorcodes = [];
      $scope.showButton = false;
      $scope.noSelected = [];
      $scope.date = [];
      function retrieveBorrowInfo(slient) {
        if (slient != true) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询..." });
        }
        apiService.retrieveBorrowInfo(
          $scope.user.borrowID,
          retrieveBorrowInfoCallback
        );
      }
      var retrieveBorrowInfoCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data) {
            $scope.loanedBooks = data.loanedBooks;
            $ionicLoading.hide();
            angular.forEach($scope.loanedBooks, function (loanedBook) {
              $scope.checkReturnBorcodes.push(loanedBook.barcode);
            });
            var barcodesJson = angular.toJson($scope.checkReturnBorcodes);
            if ($scope.loanedBooks.length != 0) {
              apiService.checkReturnOrderAllowed(
                $scope.user.borrowID,
                barcodesJson,
                {
                  onSuccess: function (data, status, config, headers) {
                    if (data.status == "OK") {
                      var div = '<div  class="noReturn"></div>';
                      var $div = $compile(div)($scope);
                      var barCodeStatus = data.data;
                      for (var key in barCodeStatus) {
                        if (!barCodeStatus[key]) {
                          angular
                            .element(document.getElementById(key))
                            .wrap($div);
                        }
                      }
                    }
                  },
                }
              );
            }
          }
        },
        onError: function (data, status, config, headers) {
          $ionicLoading.hide();
        },
        onFinally: function () {},
      };
      var retrieveHistoryBorrowInfoCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data) {
            $scope.historyLoanedBooks = data;
          }
        },
        onError: function (data, status, config, headers) {
          // TODO
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      $scope.m = [];
      $scope.checked = [];
      //全选
      $scope.selectAll = function () {
        if ($scope.select_all) {
          $scope.checked = [];
          angular.forEach($scope.loanedBooks, function (loanedBook) {
            loanedBook.checked = true;
            $scope.checked.push(loanedBook);
          });
        } else {
          angular.forEach($scope.loanedBooks, function (loanedBook) {
            loanedBook.checked = false;
            $scope.checked = [];
          });
        }
        console.log($scope.checked);
      };
      //单选
      $scope.selectOne = function () {
        angular.forEach($scope.loanedBooks, function (loanedBook) {
          var index = $scope.checked.indexOf(loanedBook.barcode);
          if (loanedBook.checked && index === -1) {
            $scope.checked.push(loanedBook.barcode);
          } else if (!loanedBook.checked && index !== -1) {
            $scope.checked.splice(index, 1);
          }
        });
        if ($scope.checked.length == 0) {
          $scope.showButton = false;
        } else if ($scope.checked.length != 0) {
          $scope.showButton = true;
        }
        if ($scope.loanedBooks.length === $scope.checked.length) {
          $scope.select_all = true;
        } else {
          $scope.select_all = false;
        }
        console.log($scope.checked);
      };
      $scope.currentState = $ionicHistory.currentStateName();
      if ($scope.currentState == "tab.minemyborrowed") {
        $scope.toLoanedBookDetail = function (loanedBook) {
          $state.go("tab.mineloanedBookDetail", { loanedBook: loanedBook });
        };
        $scope.toHistoryLoanedBookDetail = function (historyLoanedBook) {
          $state.go("tab.minehistoryLoanedBookDetail", {
            historyLoanedBook: historyLoanedBook,
          });
        };
      } else {
        $scope.toLoanedBookDetail = function (loanedBook) {
          $state.go("tab.loanedBookDetail", { loanedBook: loanedBook });
          //$event.stopPropagation();
        };
        $scope.toHistoryLoanedBookDetail = function (historyLoanedBook) {
          $state.go("tab.historyLoanedBookDetail", {
            historyLoanedBook: historyLoanedBook,
          });
        };
      }
      //还书
      $scope.returnBook = function () {
        $state.go("returnbook", { borCodes: $scope.checked });
      };
      //
      retrieveBorrowInfo();
      $ionicTabsDelegate.showBar(false);
    }
  );
