angular
  .module("starter.controllers")

  .controller(
    "discoveryBookhomeCtrl",
    function (
      $rootScope,
      $scope,
      $stateParams,
      $ionicHistory,
      $state,
      $ionicPopup,
      $ionicLoading,
      $ionicActionSheet,
      $ionicTabsDelegate,
      apiService,
      $ionicHistory
    ) {
      //
      $scope.person = $stateParams.person;
      $scope.libraryRoomInfo = null;
      $scope.allBooks = [];
      $scope.lineAllBooks = [];
      $scope.loanableBooks = [];
      $scope.lineLoanableBooks = [];
      var lineColsCapacity = 3;
      $scope.isAllBooksLoading = false;
      $scope.isLoanedBooksLoading = false;
      $scope.follow = null;

      // TODO 临时用于记住当前用户的方法
      if ($scope.person) {
        $rootScope.person = $scope.person;
      } else {
        $scope.person = $rootScope.person;
      }

      // -------------------------------------------------------------------------------------------------------------------
      $scope.getLibraryRoomShownName = function () {
        if (
          $scope.libraryRoomInfo &&
          $scope.libraryRoomInfo.libraryName &&
          $scope.libraryRoomInfo.libraryName.length > 0
        ) {
          return $scope.libraryRoomInfo.libraryName;
        } else if (
          $scope.person &&
          $scope.person.libraryRoom &&
          $scope.person.libraryRoom.libraryName &&
          $scope.person.libraryRoom.libraryName.length > 0
        ) {
          return $scope.person.libraryRoom.userNickName + "的书房";
        } else {
          return "";
        }
      };
      $scope.getUserNickNameNiName = function () {
        if (
          $scope.libraryRoomInfo &&
          $scope.libraryRoomInfo.userNickName &&
          $scope.libraryRoomInfo.userNickName.length > 0
        ) {
          return $scope.libraryRoomInfo.libraryName;
        } else if (
          $scope.person &&
          $scope.person.libraryRoom &&
          $scope.person.libraryRoom.userNickName &&
          $scope.person.libraryRoom.userNickName.length > 0
        ) {
          return $scope.person.libraryRoom.userNickName;
        } else {
          return "TA";
        }
      };

      // -------------------------------------------------------------------------------------------------------------------
      $scope.checkFollow = function () {
        apiService.checkFollow(
          $scope.person.userId,
          $scope.user.account,
          checkFollowCallback
        );
      };
      var checkFollowCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data.isMyFans) {
            $scope.follow = {
              id: data.id,
              userId: data.userId,
              followUserId: data.fansUserId,
            };
          } else {
            $scope.follow = null;
          }
        },
        onError: function (data, status, config, headers) {
          $scope.follow = null;
        },
        onFinally: function () {},
      };
      $scope.addFollow = function () {
        apiService.addFollow(
          { userId: $scope.user.account, followUserId: $scope.person.userId },
          addFollowCallback
        );
      };
      var addFollowCallback = {
        onSuccess: function (data, status, config, headers) {
          $scope.follow = data;
        },
        onError: function (data, status, config, headers) {},
        onFinally: function () {},
      };
      $scope.removeFollow = function () {
        apiService.removeFollow($scope.follow.id, removeFollowCallback);
      };
      var removeFollowCallback = {
        onSuccess: function (data, status, config, headers) {
          $scope.follow = null;
        },
        onError: function (data, status, config, headers) {},
        onFinally: function () {},
      };

      // -------------------------------------------------------------------------------------------------------------------
      // 查询用户书房信息
      $scope.queryLibraryRoomInfo = function () {
        apiService.queryLibraryRoomInfo(
          $scope.person.userId,
          queryLibraryRoomInfoCallback
        );
      };
      var queryLibraryRoomInfoCallback = {
        onSuccess: function (data, status, config, headers) {
          $scope.libraryRoomInfo = data;
        },
        onError: function (data, status, config, headers) {},
        onFinally: function () {},
      };

      // -------------------------------------------------------------------------------------------------------------------
      // 当前用户书房的所有图书
      $scope.retrieveAllBookFromUserLibraryRoom = function () {
        $scope.isAllBooksLoading = true;
        apiService.retrieveAllBooksFromUserLibraryRoom(
          $scope.person.userId,
          retrieveAllBookFromUserLibraryRoomCallback
        );
      };
      var retrieveAllBookFromUserLibraryRoomCallback = {
        onSuccess: function (data, status, config, headers) {
          // 初始化所有图书
          $scope.allBooks = data;
          if ($scope.allBooks) {
            // 初始化当前页可显示的所有图书
            $scope.lineAllBooks = [];
            for (
              var i = 0;
              i < lineColsCapacity && i < $scope.allBooks.length;
              i++
            ) {
              $scope.lineAllBooks.push($scope.allBooks[i]);
            }
            // for (var i = $scope.lineAllBooks.length; i < lineColsCapacity; i++) {
            //     $scope.lineAllBooks.push({});
            // }
          }
        },
        onError: function (data, status, config, headers) {
          // do nothing
        },
        onFinally: function () {
          $scope.isAllBooksLoading = false;
        },
      };
      // 当前用户书房的所有可借图书
      $scope.retrieveLoanableBookFromUserLibraryRoom = function () {
        $scope.isLoanedBooksLoading = true;
        apiService.retrieveLoanableBooksFromUserLibraryRoom(
          $scope.person.userId,
          retrieveLoanableBookFromUserLibraryRoomCallback
        );
      };
      var retrieveLoanableBookFromUserLibraryRoomCallback = {
        onSuccess: function (data, status, config, headers) {
          // 初始化所有可借图书
          $scope.loanableBooks = data;
          // 初始化当前可显示的可借图书
          $scope.lineLoanableBooks = [];
          for (
            var i = 0;
            i < lineColsCapacity && i < $scope.loanableBooks.length;
            i++
          ) {
            $scope.lineLoanableBooks.push($scope.loanableBooks[i]);
          }
          // for (var i = $scope.lineLoanableBooks.length; i < lineColsCapacity; i++) {
          //     $scope.lineLoanableBooks.push({});
          // }
        },
        onError: function (data, status, config, headers) {
          // do nothing
        },
        onFinally: function () {
          $scope.isLoanedBooksLoading = false;
        },
      };

      // -------------------------------------------------------------------------------------------------------------------
      $scope.goBookDetailDrift = function (book) {
        if (book) {
          var currentState = $ionicHistory.currentStateName();
          var targetStateName = undefined;
          switch (currentState) {
            case "tab.dcbhdetail":
              targetStateName = "tab.dcbookdetaildrift";
              break;
            case "tab.minedcbhdetail":
              targetStateName = "tab.minedcbookdetaildrift";
              break;
          }
          if (targetStateName) {
            $state.go(targetStateName, {
              book: book,
            });
          }
        }
      };
      $scope.goHomeBooks = function (person, loanable) {
        $ionicHistory.clearCache().then(function () {
          var currentState = $ionicHistory.currentStateName();
          var targetStateName = undefined;
          switch (currentState) {
            case "tab.dcbhdetail":
              targetStateName = "tab.dcHomeBooks";
              break;
            case "tab.minedcbhdetail":
              targetStateName = "tab.minedcHomeBooks";
              break;
          }
          if (targetStateName) {
            $state.go(targetStateName, {
              person: person,
              loanable: loanable,
            });
          }
        });
      };

      //
      $scope.queryLibraryRoomInfo();
      $scope.checkFollow();
      $scope.retrieveAllBookFromUserLibraryRoom();
      $scope.retrieveLoanableBookFromUserLibraryRoom();

      //
      $ionicTabsDelegate.showBar(false);
    }
  );
