angular
  .module("starter.controllers")

  // 图书搜索
  .controller(
    "ConditionalSearchBookCtrl",
    function (
      $rootScope,
      $scope,
      $stateParams,
      $state,
      $ionicLoading,
      apiService,
      bookService,
      uiService,
      $ionicTabsDelegate,
      appLogService
    ) {
      // ----------------------------------------------------------------------------------------------------------------

      $scope.account;
      if (!$scope.user) {
        $scope.account = "";
      } else {
        $scope.account = $rootScope.userInfo.account;
      }
      // 消息
      $scope.loadFirstTimeFailed = false;
      $scope.loadFirstTimeFailedMsg = "下拉重新搜索";
      $scope.loadMoreFailed = false;
      $scope.loadMoreFailedMsg = "加载更多失败，上拉重新加载";
      $scope.noMoreBooks = false;
      $scope.noMoreBooksMsg = "已经加载所有图书";
      $scope.noSearchBooks = "未搜索到图书";
      $scope.searchNoBooks = true;
      //
      $scope.wrd = $stateParams.wrd; // 查询关键字
      $scope.clc = $stateParams.clc; // 查询分类号
      $scope.set_number = ""; // 当前查询结果集引用
      $scope.no_entries = 0; // 当前查询结果集的总个数  注：这个总个数是server查询得到的数据总量，但不是当前的返回个数总量。
      var start = 0; // 实际开始索引
      var end = 0; // 实际结束索引
      var expectedStart = 0; // 期望开始索引
      var expectedEnd = 0; // 期望结束索引
      var span = 10; // （从第2次开始）每次查询的个数

      // ----------------------------------------------------------------------------------------------------------------
      $scope.wrd = $stateParams.wrd;
      $scope.clc = $stateParams.clc;

      // ----------------------------------------------------------------------------------------------------------------
      $scope.moreDataCanBeLoaded = function () {
        return (
          $scope.refreshSuccessful &&
          !$scope.noMoreBooks &&
          !$scope.loadBooksAbnormal
        );
      };

      // ----------------------------------------------------------------------------------------------------------------
      // 第一次加载搜索结果  结果中包含结果集引用值以及总的搜索结果
      function checkField() {
        if ($scope.wrd && $scope.wrd.replace(/(^s*)|(s*$)/g, "").length > 0) {
          return true;
        }
        if ($scope.wrd2 && $scope.wrd2.replace(/(^s*)|(s*$)/g, "").length > 0) {
          return true;
        }
        if ($scope.clc && $scope.clc.replace(/(^s*)|(s*$)/g, "").length > 0) {
          return true;
        }
        return false;
      }
      //
      $scope.isQueryFirst = undefined;
      $scope.refresh = function () {
        // load first time
        if (!checkField()) {
          $scope.$broadcast("scroll.refreshComplete");
          return;
        }
        //
        $scope.refreshSuccessful = false;
        $scope.noMoreBooks = false;
        $scope.set_number = null;
        $scope.books = [];

        uiService.ionicLoadingShow({ templateTitle: "正在搜索..." });

        $scope.isQueryFirst = true;
        apiService.searchBooks(
          {
            wrd: $scope.wrd,
            clc: $scope.clc,
          },
          $scope.account,
          {
            onSuccess: onSuccess,
            onError: onError,
            onFinally: onFinally,
          }
        );
      };
      // 加载更多
      $scope.loadMore = function () {
        if ($scope.noMoreBooks == true) {
          return;
        }
        $scope.isQueryFirst = false;
        expectedStart = end + 1;
        expectedEnd = end + span;
        apiService.searchBooksMore(
          $scope.set_number,
          expectedStart,
          expectedEnd,
          $scope.account,
          {
            onSuccess: onSuccess,
            onError: onError,
            onFinally: onFinally,
          }
        );
      };
      // 加载更多的事件监听器
      function onSuccess(data) {
        if (data.books.length != 0) {
          // $scope.searchNoBooks = true;
          var books = data.books;
          bookService.fixBooks(books);
          //
          if (data.set_number) {
            // 记录返回的数据
            $scope.set_number = data.set_number;
            $scope.no_entries = parseInt(data.no_entries);
            //
            if (books.length >= 1) {
              start = 1;
              end = books.length;
            }
            $scope.books = books;
            $scope.refreshSuccessful = true;
          } else {
            //
            $scope.loadMoreFailed = false;
            // 设置当前的实际值
            if ($scope.books) {
              for (var i = 0; i < books.length; i++) {
                $scope.books.push(books[i]);
              }
            } else {
              $scope.books = books;
            }
            start = expectedStart;
            end = $scope.books.length;
          }
          // 判断是否还有剩余图书没有拉取
          if ($scope.books.length == $scope.no_entries) {
            $scope.noMoreBooks = true;
          } else if ($scope.books.length < $scope.no_entries) {
            $scope.noMoreBooks = false;
          } // 不可能出现大于的情况
        } else {
          // $scope.searchNoBooks = false; // 空数据，显示“未搜索图书”
        }

        // *** 处理服务器异常：应该还有图书没有返回，但是实际返回的图书为空。当然这不应该出现，但是有时候服务器可能就这么“傻”，需要处理一下。
        if ($scope.refreshSuccessful && !$scope.noMoreBooks) {
          if (!books || books.length == 0) {
            $scope.loadBooksAbnormal = true;
            //
            var log = appLogService.getBaseLog();
            log.level = "warn";
            log.category = "module";
            log.module = "search_book";
            log.error = {
              desciption:
                "图书查询中发现服务器返回数据异常：还应该有图书可以继续获取，但是实际获取的图书为0本，这不符合事实。",
              set_number: $scope.set_number,
              no_entries: $scope.no_entries,
              current_books: angular.toJson($scope.books),
              actual_data_from_server: angular.toJson(data),
            };
            appLogService.uploadLog(log, {
              onSuccess: function (data, status, config, headers) {
                console.log("提交图书查询异常日志-->成功");
              },
              onError: function (data, status, config, headers) {
                console.error("提交图书查询异常日志-->失败");
              },
              onFinally: function () {
                //
              },
            });
          }
        }
        // ***
      }
      function onError() {
        if ($scope.set_number) {
          $scope.loadMoreFailed = true;
        } else {
          $scope.refreshFailed = true;
        }
      }
      function onFinally() {
        // 隐藏进度条
        if ($scope.isQueryFirst == true) {
          $scope.$broadcast("scroll.refreshComplete");
        } else {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        }
        $ionicLoading.hide();
      }

      // ----------------------------------------------------------------------------------------------------------------
      $scope.goDetail = function (book) {
        $state.go("tab.book-detail", { book: book });
      };

      // ----------------------------------------------------------------------------------------------------------------
      // 主动搜索一次
      $scope.loadFirstTime = function () {
        $scope.refresh();
      };
      $scope.loadFirstTime();

      $ionicTabsDelegate.showBar(false);
    }
  );
