angular
  .module("starter.controllers")

  .controller(
    "OrderConfirmCtrl",
    function (
      $ionicHistory,
      $rootScope,
      $scope,
      $stateParams,
      $state,
      $ionicPopup,
      apiService,
      $ionicTabsDelegate,
      uiService,
      $ionicLoading,
      ngCordovaService,
      broadcastConstants,
      broadcastService,
      appLogService
    ) {
      //
      $scope.books = $stateParams.book; // 当前图书
      //$scope.groupBookIds = $stateParams.groupBookIds;
      $scope.groupBookIds = $stateParams.groupBookIdsJson;
      $scope.reserveItemIds = $stateParams.bookIdJson;
      //$scope.allowLoanedBooks = $stateParams.allowLoanedBooks; // 当前所有可借图书

      $scope.deliverModeOptions = [
        { id: "快递", value: "快递" },
        { id: "自取", value: "自取" },
      ];
      var bookCount = 0;
      $scope.receiver = {};
      $scope.data = {
        currentDeliverMode: "快递",
        currentLibrary: "大兴区图书馆",
        subLibraries: [],
      };
      $scope.subLibraries = [];
      init();
      function init() {
        apiService.getLibraryBranch({
          onSuccess: function (data, status, config, headers) {
            if (data.status == "OK") {
              angular.forEach(
                data.data,
                function (anyData) {
                  $scope.subLibraries.push(anyData.address);
                },
                this
              );
            }
            $scope.data.subLibraries = data;
          },
        });
        if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        } else {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        apiService.findDefaultAddress($rootScope.userInfo.account, {
          onSuccess: function (data, status, config, headers) {
            $scope.setDefaultAddress = data.data;
            if (!_.isEmpty($scope.setDefaultAddress)) {
              $scope.receiver.receiverName =
                $scope.setDefaultAddress.receiverName;
              $scope.receiver.receiverPhone =
                $scope.setDefaultAddress.telephone;
              $scope.receiver.receiverAddress =
                $scope.setDefaultAddress.address;
            } else {
              if ($scope.userInfo) {
                $scope.receiver.receiverAddress = $rootScope.pickAddress;
                $scope.receiver.receiverName = $scope.userInfo.name;
                $scope.receiver.receiverPhone = $scope.userInfo.telephone;
              }
            }
          },
        });
      }
      $scope.cities;
      $scope.areas;
      $scope.proToCity = function () {
        $scope.cities = $scope.pro.cityList;
      };
      $scope.cityToArea = function () {
        $scope.areas = $scope.city.areaList;
      };
      $scope.provinces = [
        {
          name: "北京",
          cityList: [
            {
              name: "大兴区",
              areaList: $scope.subLibraries,
            },
          ],
        },
      ];

      $scope.defaultAddress = "北京市大兴区";
      $scope.confirmOrder = function () {
        // $state.go('tab.mine');
        if (_.isEmpty($scope.data.currentDeliverMode)) {
          ngCordovaService.showToast("请先选择配送方式");
          return;
        }
        if (_.isEmpty($scope.receiver.receiverName)) {
          ngCordovaService.showToast("收件人名字不能为空");
          return;
        }
        if (_.isEmpty($scope.receiver.receiverPhone)) {
          ngCordovaService.showToast("手机号码不能为空");
          return;
        }
        if (
          !/^0?(13|14|15|17|18)[0-9]{9}$/.test($scope.receiver.receiverPhone)
        ) {
          ngCordovaService.showToast("手机号码格式错误，请重填");
          return;
        }
        var receiverAddress = undefined;
        switch ($scope.data.currentDeliverMode) {
          case "自取":
            if (_.isEmpty($scope.area)) {
              ngCordovaService.showToast("请先选择您要取书的分馆地址");
              return;
            }
            receiverAddress = $scope.area;
            $scope.data.currentDeliverMode = "pickup";
            break;
          case "快递":
            if (
              _.isEmpty($scope.receiver.receiverAddress) ||
              $scope.receiver.receiverAddress.replace(/(^s*)|(s*$)/g, "")
                .length == 0
            ) {
              ngCordovaService.showToast("收货地址不能为空");
              return;
            }
            receiverAddress =
              $scope.defaultAddress + $scope.receiver.receiverAddress;
            $scope.data.currentDeliverMode = "express";
            break;
          default:
            return;
          // break;
        }
        uiService.ionicLoadingShow({ templateTitle: "正在创建订单..." });
        //
        var bookGroupIdAndCounts = {};
        $scope.books.forEach(function (book) {
          if (!_.isEmpty(book)) {
            bookGroupIdAndCounts[book.groupBookId] = book.bookCount;
          }
        }, this);
        if (_.isEmpty($scope.reserveItemIds)) {
          apiService.createOrder(
            {
              accountId: $scope.user.account,
              borrowerId: $scope.user.borrowID,
              borrowerName: $scope.user.name,
              //bookImages: $scope.books.bookImage,
              bookGroupIdAndCounts: bookGroupIdAndCounts, // $scope.allowLoanedBook.barCode,
              receiverName: $scope.receiver.receiverName,
              receiverAddress: receiverAddress,
              receiverPhone: $scope.receiver.receiverPhone,
              borrowType: $scope.data.currentDeliverMode,
            },
            confirmOrderCallback
          );
        } else if (_.isEmpty($scope.groupBookIds)) {
          apiService.loanReserveBooks(
            {
              accountId: $scope.user.account,
              borrowerId: $scope.user.borrowID,
              borrowerName: $scope.user.name,
              //bookImages: $scope.books.bookImage,
              reserveItemIds: $scope.reserveItemIds, // $scope.allowLoanedBook.barCode,
              receiverName: $scope.receiver.receiverName,
              receiverAddress: receiverAddress,
              receiverPhone: $scope.receiver.receiverPhone,
              borrowType: $scope.data.currentDeliverMode,
            },
            confirmOrderCallback
          );
        }
      };
      var confirmOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data.status == "OK") {
            if (_.isEmpty($scope.reserveItemIds)) {
              apiService.deleteCartBooks(
                $rootScope.user.borrowID,
                $scope.groupBookIds,
                {
                  onSuccess: function (data, status, config, headers) {
                    console.log(data);
                  },
                }
              );
            }
            //获取用户不同状态的订单数量
            apiService.checkAllOrder($rootScope.user.borrowID, {
              onSuccess: function (data, status, config, headers) {
                if (data) {
                  console.log(data);
                  var amountCount = 0;
                  if (data.packing) {
                    amountCount += parseInt(data.packing);
                  }
                  if (data.paying) {
                    amountCount += parseInt(data.paying);
                  }
                  if (data.delivering) {
                    amountCount += parseInt(data.delivering);
                  }
                  if (data.receiving) {
                    amountCount += parseInt(data.receiving);
                  }
                  if (data.picking) {
                    amountCount += parseInt(data.picking);
                  }
                  $rootScope.myOrderCount = amountCount;
                  if ($rootScope.myOrderCount == 0) {
                    $rootScope.numberShow = false;
                  } else {
                    $rootScope.numberShow = true;
                  }
                }
              },
            });
            $ionicHistory.clearHistory();
            $ionicHistory.nextViewOptions({
              disableBack: true,
            });
            $state.go("tab.mine");
            ngCordovaService.showToast(
              "创建订单成功，请在“我的借书包裹”中查看详情"
            );
          } else {
            //ngCordovaService.showToast(data.data);
            $ionicPopup.alert({
              title: "创建订单失败",
              template: data.data,
              okText: "确定",
            });
            //$state.go('tab.mine');
            $scope.data = {
              currentDeliverMode: "快递",
              currentLibrary: "大兴区图书馆",
              subLibraries: [],
            };
          }
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("创建订单失败");
          $scope.data = {
            currentDeliverMode: "快递",
            currentLibrary: "大兴区图书馆",
            subLibraries: [],
          };
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };
      $scope.goSelectAddress = function () {
        $state.go("tab.selectaddress");
      };

      // ----------------------------------------------------------------------------------------------------------------
      $scope.submitErrorLog = function (server_data, module, desciption) {
        var log = appLogService.getBaseLog();
        log.level = "warn";
        log.category = "module";
        log.module = module;
        log.error = {
          desciption: desciption,
          actual_data_from_server: angular.toJson(server_data),
        };
        appLogService.uploadLog(log, {
          onSuccess: function (data, status, config, headers) {
            console.log("提交异常日志-->成功");
          },
          onError: function (data, status, config, headers) {
            console.error("提交异常日志-->失败");
          },
          onFinally: function () {
            //
          },
        });
      };
      //选取收货地址的广播
      var onaddressSelectedListener = function (adr) {
        if (adr) {
          $scope.receiver.receiverName = adr.receiverName;
          $scope.receiver.receiverPhone = adr.telephone;
          $scope.receiver.receiverAddress = adr.address;
        }
      };
      broadcastService.register(
        broadcastConstants.names.addressSelected,
        onaddressSelectedListener
      );
      $scope.$on("$destroy", function () {
        broadcastService.unregister(
          broadcastConstants.names.addressSelected,
          onaddressSelectedListener
        );
      });
      //删除地址的广播
      var onaddressDeleteListener = function (editAdr) {
        if (
          editAdr.receiverName == $scope.receiver.receiverName &&
          editAdr.telephone == $scope.receiver.receiverPhone &&
          editAdr.address == $scope.receiver.receiverAddress
        ) {
          console.log(editAdr);
          init();
        }
      };
      broadcastService.register(
        broadcastConstants.names.addressDelete,
        onaddressDeleteListener
      );
      $scope.$on("$destroy", function () {
        broadcastService.unregister(
          broadcastConstants.names.addressDelete,
          onaddressDeleteListener
        );
      });
      $ionicTabsDelegate.showBar(false);
    }
  );
