angular
  .module("starter.controllers")

  .controller(
    "reservedBookDetailCtrl",
    function (
      $controller,
      $scope,
      $stateParams,
      $state,
      $ionicHistory,
      $ionicPopup,
      apiService,
      bookService,
      ngCordovaService,
      $ionicSlideBoxDelegate,
      $ionicTabsDelegate,
      broadcastService,
      broadcastConstants
    ) {
      // --------------------------------------------------------------------------------------------
      $scope.reservedBook = $stateParams.reservedBook;

      // --------------------------------------------------------------------------------------------
      $scope.cancelReserveBook = function () {
        apiService.cancelReserveBook1(
          $scope.reservedBook.recKey,
          cancelReserveBookCallback
        );
      };
      var cancelReserveBookCallback = {
        onSuccess: function (data, status, config, headers) {
          var msg = "";
          if (data) {
            var status = data.status; // 目前已知的状态有：'success','fail'
            if (status == "success") {
              msg = "取消预约成功";
            } else if (status == "fail") {
              msg = "取消预约失败";
            } else {
              msg = data.msg;
            }
          } else {
            msg = "未知结果！";
          }
          $ionicPopup
            .alert({
              title: msg,
              okText: "确定",
            })
            .then(function () {
              // TODO 临时什么也不做，发现history方式有问题
              // // 返回上一页面
              // $ionicHistory.goBack(-1);
              $state.go("tab.home");
            });
          /*****************wsc-change***************************/
          //发送广播
          broadcastService.send(
            broadcastConstants.names.onReservedBookChanged,
            {
              operation: "reserve",
              result: "success",
              book: $scope.reservedBook,
            }
          );
        },
        onError: function (data, status, config, headers) {
          var msg = "取消预约失败";
          $ionicPopup
            .alert({
              title: msg,
              okText: "确定",
            })
            .then(function () {
              $state.go("tab.home");
            });
        },
      };

      // ----------------------------------------------------------------------------------------------------------------
      $ionicTabsDelegate.showBar(false);

      // ----------------------------------------------------------------------------------------------------------------
      // 获取base controller，并将其扩展至当前controller中。
      var baseBookDetailCtrl = $controller("baseBookDetailCtrl", {
        $scope: $scope,
      });
      angular.extend(this, baseBookDetailCtrl);
      if ($scope.reservedBook) {
        $scope.init($scope.reservedBook.isbn); // init函数是base controller中的
      }
    }
  );
