angular
  .module("starter.controllers")

  .controller(
    "YouchooseIpayBooksInStoreCtrl",
    function (
      $scope,
      $state,
      $stateParams,
      $ionicPopup,
      $ionicLoading,
      apiService,
      uiService,
      $ionicHistory,
      $ionicTabsDelegate
    ) {
      // ----------------------------------------------------------------------------------------------------
      $scope.bookStore = $stateParams.bookStore;
      $scope.books = null;

      // ----------------------------------------------------------------------------------------------------
      $scope.retrieveBookStoreBooks = function () {
        uiService.ionicLoadingShow({ templateTitle: "正在搜索图书..." });
        apiService.retrieveBookStoreBooks(
          $scope.bookStore.bookstoreId,
          retrieveBookStoreBooksCallback
        );
      };
      var retrieveBookStoreBooksCallback = {
        onSuccess: function (data, status, config, headers) {
          $scope.books = data;
        },
        onError: function (data, status, config, headers) {},
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      // ----------------------------------------------------------------------------------------------------
      $scope.currentState = $ionicHistory.currentStateName();
      if ($scope.currentState == "tab.youchooseipay_books_in_store") {
        $scope.goBookDetail = function (book) {
          $state.go("tab.youchooseipay_ic_book_detail", {
            book: book.basebook,
            storeBook: book.storeBook,
          });
        };
      } else {
        $scope.goBookDetail = function (book) {
          $state.go("tab.mineyouchooseipay_ic_book_detail", {
            book: book.basebook,
            storeBook: book.storeBook,
          });
        };
      }

      // ----------------------------------------------------------------------------------------------------
      $ionicTabsDelegate.showBar(false);

      //
      $scope.retrieveBookStoreBooks();
    }
  );
